<!DOCTYPE html>
<html xmlns="http://www.w3.org/1999/xhtml" lang="" xml:lang="">
<head>
  <meta charset="utf-8" />
  <meta name="generator" content="pandoc" />
  <meta name="viewport" content="width=device-width, initial-scale=1.0, user-scalable=yes" />
  <title>ansi-escape</title>
  <style type="text/css">
      code{white-space: pre-wrap;}
      span.smallcaps{font-variant: small-caps;}
      span.underline{text-decoration: underline;}
      div.column{display: inline-block; vertical-align: top; width: 50%;}
  </style>
  <style type="text/css">
a.sourceLine { display: inline-block; line-height: 1.25; }
a.sourceLine { pointer-events: none; color: inherit; text-decoration: inherit; }
a.sourceLine:empty { height: 1.2em; }
.sourceCode { overflow: visible; }
code.sourceCode { white-space: pre; position: relative; }
div.sourceCode { margin: 1em 0; }
pre.sourceCode { margin: 0; }
@media screen {
div.sourceCode { overflow: auto; }
}
@media print {
code.sourceCode { white-space: pre-wrap; }
a.sourceLine { text-indent: -1em; padding-left: 1em; }
}
pre.numberSource a.sourceLine
  { position: relative; left: -4em; }
pre.numberSource a.sourceLine::before
  { content: attr(title);
    position: relative; left: -1em; text-align: right; vertical-align: baseline;
    border: none; pointer-events: all; display: inline-block;
    -webkit-touch-callout: none; -webkit-user-select: none;
    -khtml-user-select: none; -moz-user-select: none;
    -ms-user-select: none; user-select: none;
    padding: 0 4px; width: 4em;
    color: #aaaaaa;
  }
pre.numberSource { margin-left: 3em; border-left: 1px solid #aaaaaa;  padding-left: 4px; }
div.sourceCode
  {  }
@media screen {
a.sourceLine::before { text-decoration: underline; }
}
code span.al { color: #ff0000; font-weight: bold; } /* Alert */
code span.an { color: #60a0b0; font-weight: bold; font-style: italic; } /* Annotation */
code span.at { color: #7d9029; } /* Attribute */
code span.bn { color: #40a070; } /* BaseN */
code span.bu { } /* BuiltIn */
code span.cf { color: #007020; font-weight: bold; } /* ControlFlow */
code span.ch { color: #4070a0; } /* Char */
code span.cn { color: #880000; } /* Constant */
code span.co { color: #60a0b0; font-style: italic; } /* Comment */
code span.cv { color: #60a0b0; font-weight: bold; font-style: italic; } /* CommentVar */
code span.do { color: #ba2121; font-style: italic; } /* Documentation */
code span.dt { color: #902000; } /* DataType */
code span.dv { color: #40a070; } /* DecVal */
code span.er { color: #ff0000; font-weight: bold; } /* Error */
code span.ex { } /* Extension */
code span.fl { color: #40a070; } /* Float */
code span.fu { color: #06287e; } /* Function */
code span.im { } /* Import */
code span.in { color: #60a0b0; font-weight: bold; font-style: italic; } /* Information */
code span.kw { color: #007020; font-weight: bold; } /* Keyword */
code span.op { color: #666666; } /* Operator */
code span.ot { color: #007020; } /* Other */
code span.pp { color: #bc7a00; } /* Preprocessor */
code span.sc { color: #4070a0; } /* SpecialChar */
code span.ss { color: #bb6688; } /* SpecialString */
code span.st { color: #4070a0; } /* String */
code span.va { color: #19177c; } /* Variable */
code span.vs { color: #4070a0; } /* VerbatimString */
code span.wa { color: #60a0b0; font-weight: bold; font-style: italic; } /* Warning */
  </style>
</head>
<body>
<h1 id="ansi-escape-sequences">ANSI Escape Sequences</h1>
<p>Standard escape codes are prefixed with <code>Escape</code>:</p>
<ul>
<li>Ctrl-Key: <code>^[</code></li>
<li>Octal: <code>\033</code></li>
<li>Unicode: <code>\u001b</code></li>
<li>Hexadecimal: <code>\x1b</code></li>
<li>Decimal: <code>27</code></li>
</ul>
<p>Followed by the command, somtimes delimited by opening square bracket (<code>[</code>), known as a Control Sequence Introducer (CSI), optionally followed by arguments and the command itself.</p>
<p>Arguments are delimeted by semi colon (<code>;</code>).</p>
<p>For example:</p>
<div class="sourceCode" id="cb1"><pre class="sourceCode sh"><code class="sourceCode bash"><a class="sourceLine" id="cb1-1" title="1">\<span class="ex">x1b</span>[1<span class="kw">;</span><span class="ex">31m</span>  <span class="co"># Set style to bold, red foreground.</span></a></code></pre></div>
<h2 id="general-ascii-codes">General ASCII Codes</h2>
<table>
<thead>
<tr class="header">
<th>Name</th>
<th>decimal</th>
<th>octal</th>
<th>hex</th>
<th>C-escape</th>
<th>Ctrl-Key</th>
<th>Description</th>
</tr>
</thead>
<tbody>
<tr class="odd">
<td><code>BEL</code></td>
<td>7</td>
<td>007</td>
<td>0x07</td>
<td><code>\a</code></td>
<td><code>^G</code></td>
<td>Terminal bell</td>
</tr>
<tr class="even">
<td><code>BS</code></td>
<td>8</td>
<td>010</td>
<td>0x08</td>
<td><code>\b</code></td>
<td><code>^H</code></td>
<td>Backspace</td>
</tr>
<tr class="odd">
<td><code>HT</code></td>
<td>9</td>
<td>011</td>
<td>0x09</td>
<td><code>\t</code></td>
<td><code>^I</code></td>
<td>Horizontal TAB</td>
</tr>
<tr class="even">
<td><code>LF</code></td>
<td>10</td>
<td>012</td>
<td>0x0A</td>
<td><code>\n</code></td>
<td><code>^J</code></td>
<td>Linefeed (newline)</td>
</tr>
<tr class="odd">
<td><code>VT</code></td>
<td>11</td>
<td>013</td>
<td>0x0B</td>
<td><code>\v</code></td>
<td><code>^K</code></td>
<td>Vertical TAB</td>
</tr>
<tr class="even">
<td><code>FF</code></td>
<td>12</td>
<td>014</td>
<td>0x0C</td>
<td><code>\f</code></td>
<td><code>^L</code></td>
<td>Formfeed (also: New page <code>NP</code>)</td>
</tr>
<tr class="odd">
<td><code>CR</code></td>
<td>13</td>
<td>015</td>
<td>0x0D</td>
<td><code>\r</code></td>
<td><code>^M</code></td>
<td>Carriage return</td>
</tr>
<tr class="even">
<td><code>ESC</code></td>
<td>27</td>
<td>033</td>
<td>0x1B</td>
<td><code>\e</code><a href="#escape">*</a></td>
<td><code>^[</code></td>
<td>Escape character</td>
</tr>
<tr class="odd">
<td><code>DEL</code></td>
<td>127</td>
<td>177</td>
<td>0x7F</td>
<td><code>&lt;none&gt;</code></td>
<td><code>&lt;none&gt;</code></td>
<td>Delete character</td>
</tr>
</tbody>
</table>
<div id="escape">

</div>
<blockquote>
<p><strong>Note:</strong> Some control escape sequences, like <code>\e</code> for <code>ESC</code>, are not guaranteed to work in all languages and compilers. It is recommended to use the decimal, octal or hex representation as escape code.</p>
</blockquote>
<blockquote>
<p><strong>Note:</strong> The <strong>Ctrl-Key</strong> representation is simply associating the non-printable characters from ASCII code 1 with the printable (letter) characters from ASCII code 65 (“A”). ASCII code 1 would be <code>^A</code> (Ctrl-A), while ASCII code 7 (BEL) would be <code>^G</code> (Ctrl-G). This is a common representation (and input method) and historically comes from one of the VT series of terminals.</p>
</blockquote>
<h2 id="cursor-controls">Cursor Controls</h2>
<table>
<colgroup>
<col style="width: 48%" />
<col style="width: 51%" />
</colgroup>
<thead>
<tr class="header">
<th style="text-align: left;">ESC Code Sequence</th>
<th style="text-align: left;">Description</th>
</tr>
</thead>
<tbody>
<tr class="odd">
<td style="text-align: left;"><code>ESC[H</code></td>
<td style="text-align: left;">moves cursor to home position (0, 0)</td>
</tr>
<tr class="even">
<td style="text-align: left;"><code>ESC[{line};{column}H</code> <br> <code>ESC[{line};{column}f</code></td>
<td style="text-align: left;">moves cursor to line #, column #</td>
</tr>
<tr class="odd">
<td style="text-align: left;"><code>ESC[#A</code></td>
<td style="text-align: left;">moves cursor up # lines</td>
</tr>
<tr class="even">
<td style="text-align: left;"><code>ESC[#B</code></td>
<td style="text-align: left;">moves cursor down # lines</td>
</tr>
<tr class="odd">
<td style="text-align: left;"><code>ESC[#C</code></td>
<td style="text-align: left;">moves cursor right # columns</td>
</tr>
<tr class="even">
<td style="text-align: left;"><code>ESC[#D</code></td>
<td style="text-align: left;">moves cursor left # columns</td>
</tr>
<tr class="odd">
<td style="text-align: left;"><code>ESC[#E</code></td>
<td style="text-align: left;">moves cursor to beginning of next line, # lines down</td>
</tr>
<tr class="even">
<td style="text-align: left;"><code>ESC[#F</code></td>
<td style="text-align: left;">moves cursor to beginning of previous line, # lines up</td>
</tr>
<tr class="odd">
<td style="text-align: left;"><code>ESC[#G</code></td>
<td style="text-align: left;">moves cursor to column #</td>
</tr>
<tr class="even">
<td style="text-align: left;"><code>ESC[6n</code></td>
<td style="text-align: left;">request cursor position (reports as <code>ESC[#;#R</code>)</td>
</tr>
<tr class="odd">
<td style="text-align: left;"><code>ESC7</code></td>
<td style="text-align: left;">save cursor position (DEC)</td>
</tr>
<tr class="even">
<td style="text-align: left;"><code>ESC8</code></td>
<td style="text-align: left;">restores the cursor to the last saved position (DEC)</td>
</tr>
<tr class="odd">
<td style="text-align: left;"><code>ESC[s</code></td>
<td style="text-align: left;">save cursor position (SCO)</td>
</tr>
<tr class="even">
<td style="text-align: left;"><code>ESC[u</code></td>
<td style="text-align: left;">restores the cursor to the last saved position (SCO)</td>
</tr>
</tbody>
</table>
<blockquote>
<p><strong>Note:</strong> Some sequences, like saving and restoring cursors, are private sequences and are not standardized. While some terminal emulators (i.e. xterm and derived) support both SCO and DEC sequences, they are likely to have different functionality. It is therefore recommended to use DEC sequences.</p>
</blockquote>
<h2 id="erase-functions">Erase Functions</h2>
<table>
<thead>
<tr class="header">
<th style="text-align: left;">ESC Code Sequence</th>
<th style="text-align: left;">Description</th>
</tr>
</thead>
<tbody>
<tr class="odd">
<td style="text-align: left;"><code>ESC[J</code></td>
<td style="text-align: left;">clears the screen</td>
</tr>
<tr class="even">
<td style="text-align: left;"><code>ESC[0J</code></td>
<td style="text-align: left;">clears from cursor until end of screen</td>
</tr>
<tr class="odd">
<td style="text-align: left;"><code>ESC[1J</code></td>
<td style="text-align: left;">clears from cursor to beginning of screen</td>
</tr>
<tr class="even">
<td style="text-align: left;"><code>ESC[2J</code></td>
<td style="text-align: left;">clears entire screen</td>
</tr>
<tr class="odd">
<td style="text-align: left;"><code>ESC[K</code></td>
<td style="text-align: left;">clears the current line</td>
</tr>
<tr class="even">
<td style="text-align: left;"><code>ESC[0K</code></td>
<td style="text-align: left;">clears from cursor to end of line</td>
</tr>
<tr class="odd">
<td style="text-align: left;"><code>ESC[1K</code></td>
<td style="text-align: left;">clears from cursor to start of line</td>
</tr>
<tr class="even">
<td style="text-align: left;"><code>ESC[2K</code></td>
<td style="text-align: left;">clears entire line</td>
</tr>
</tbody>
</table>
<h2 id="colors-graphics-mode">Colors / Graphics Mode</h2>
<table>
<thead>
<tr class="header">
<th style="text-align: left;">ESC Code Sequence</th>
<th style="text-align: left;">Reset Sequence</th>
<th style="text-align: left;">Description</th>
</tr>
</thead>
<tbody>
<tr class="odd">
<td style="text-align: left;"><code>ESC[1;34;{...}m</code></td>
<td style="text-align: left;"></td>
<td style="text-align: left;">Set graphics modes for cell, separated by semicolon (<code>;</code>).</td>
</tr>
<tr class="even">
<td style="text-align: left;"><code>ESC[0m</code></td>
<td style="text-align: left;"><code>ESC[0m</code></td>
<td style="text-align: left;">reset all modes (styles and colors)</td>
</tr>
<tr class="odd">
<td style="text-align: left;"><code>ESC[1m</code></td>
<td style="text-align: left;"><code>ESC[22m</code></td>
<td style="text-align: left;">set bold mode.</td>
</tr>
<tr class="even">
<td style="text-align: left;"><code>ESC[2m</code></td>
<td style="text-align: left;"><code>ESC[22m</code></td>
<td style="text-align: left;">set dim/faint mode.</td>
</tr>
<tr class="odd">
<td style="text-align: left;"><code>ESC[3m</code></td>
<td style="text-align: left;"><code>ESC[23m</code></td>
<td style="text-align: left;">set italic mode.</td>
</tr>
<tr class="even">
<td style="text-align: left;"><code>ESC[4m</code></td>
<td style="text-align: left;"><code>ESC[24m</code></td>
<td style="text-align: left;">set underline mode.</td>
</tr>
<tr class="odd">
<td style="text-align: left;"><code>ESC[5m</code></td>
<td style="text-align: left;"><code>ESC[25m</code></td>
<td style="text-align: left;">set blinking mode</td>
</tr>
<tr class="even">
<td style="text-align: left;"><code>ESC[7m</code></td>
<td style="text-align: left;"><code>ESC[27m</code></td>
<td style="text-align: left;">set inverse/reverse mode</td>
</tr>
<tr class="odd">
<td style="text-align: left;"><code>ESC[8m</code></td>
<td style="text-align: left;"><code>ESC[28m</code></td>
<td style="text-align: left;">set hidden/invisible mode</td>
</tr>
<tr class="even">
<td style="text-align: left;"><code>ESC[9m</code></td>
<td style="text-align: left;"><code>ESC[29m</code></td>
<td style="text-align: left;">set strikethrough mode.</td>
</tr>
</tbody>
</table>
<blockquote>
<p><strong>Note:</strong> Some terminals may not support some of the graphic mode sequences listed above.</p>
</blockquote>
<h3 id="color-codes">Color codes</h3>
<p>Most terminals support 8 and 16 colors, as well as 256 (8-bit) colors. These colors are set by the user, but have commonly defined meanings.</p>
<h4 id="colors">8-16 Colors</h4>
<table>
<thead>
<tr class="header">
<th style="text-align: left;">Color Name</th>
<th style="text-align: left;">Foreground Color Code</th>
<th style="text-align: left;">Background Color Code</th>
</tr>
</thead>
<tbody>
<tr class="odd">
<td style="text-align: left;">Black</td>
<td style="text-align: left;"><code>30</code></td>
<td style="text-align: left;"><code>40</code></td>
</tr>
<tr class="even">
<td style="text-align: left;">Red</td>
<td style="text-align: left;"><code>31</code></td>
<td style="text-align: left;"><code>41</code></td>
</tr>
<tr class="odd">
<td style="text-align: left;">Green</td>
<td style="text-align: left;"><code>32</code></td>
<td style="text-align: left;"><code>42</code></td>
</tr>
<tr class="even">
<td style="text-align: left;">Yellow</td>
<td style="text-align: left;"><code>33</code></td>
<td style="text-align: left;"><code>43</code></td>
</tr>
<tr class="odd">
<td style="text-align: left;">Blue</td>
<td style="text-align: left;"><code>34</code></td>
<td style="text-align: left;"><code>44</code></td>
</tr>
<tr class="even">
<td style="text-align: left;">Magenta</td>
<td style="text-align: left;"><code>35</code></td>
<td style="text-align: left;"><code>45</code></td>
</tr>
<tr class="odd">
<td style="text-align: left;">Cyan</td>
<td style="text-align: left;"><code>36</code></td>
<td style="text-align: left;"><code>46</code></td>
</tr>
<tr class="even">
<td style="text-align: left;">White</td>
<td style="text-align: left;"><code>37</code></td>
<td style="text-align: left;"><code>47</code></td>
</tr>
<tr class="odd">
<td style="text-align: left;">Default</td>
<td style="text-align: left;"><code>39</code></td>
<td style="text-align: left;"><code>49</code></td>
</tr>
<tr class="even">
<td style="text-align: left;">Reset</td>
<td style="text-align: left;"><code>0</code></td>
<td style="text-align: left;"><code>0</code></td>
</tr>
</tbody>
</table>
<blockquote>
<p><strong>Note:</strong> the <em>Reset</em> color is the reset code that resets <em>all</em> colors and text effects, Use <em>Default</em> color to reset colors only.</p>
</blockquote>
<p>Most terminals, apart from the basic set of 8 colors, also support the “bright” or “bold” colors. These have their own set of codes, mirroring the normal colors, but with an additional <code>;1</code> in their codes:</p>
<div class="sourceCode" id="cb2"><pre class="sourceCode sh"><code class="sourceCode bash"><a class="sourceLine" id="cb2-1" title="1"><span class="co"># Set style to bold, red foreground.</span></a>
<a class="sourceLine" id="cb2-2" title="2">\<span class="ex">x1b</span>[1<span class="kw">;</span><span class="ex">31mHello</span></a>
<a class="sourceLine" id="cb2-3" title="3"><span class="co"># Set style to dimmed white foreground with red background.</span></a>
<a class="sourceLine" id="cb2-4" title="4">\<span class="ex">x1b</span>[2<span class="kw">;</span><span class="ex">37</span><span class="kw">;</span><span class="ex">41mWorld</span></a></code></pre></div>
<p>Terminals that support the <a href="https://sites.ualberta.ca/dept/chemeng/AIX-43/share/man/info/C/a_doc_lib/cmds/aixcmds1/aixterm.htm">aixterm specification</a> provides bright versions of the ISO colors, without the need to use the bold modifier:</p>
<table>
<thead>
<tr class="header">
<th style="text-align: left;">Color Name</th>
<th style="text-align: left;">Foreground Color Code</th>
<th style="text-align: left;">Background Color Code</th>
</tr>
</thead>
<tbody>
<tr class="odd">
<td style="text-align: left;">Bright Black</td>
<td style="text-align: left;"><code>90</code></td>
<td style="text-align: left;"><code>100</code></td>
</tr>
<tr class="even">
<td style="text-align: left;">Bright Red</td>
<td style="text-align: left;"><code>91</code></td>
<td style="text-align: left;"><code>101</code></td>
</tr>
<tr class="odd">
<td style="text-align: left;">Bright Green</td>
<td style="text-align: left;"><code>92</code></td>
<td style="text-align: left;"><code>102</code></td>
</tr>
<tr class="even">
<td style="text-align: left;">Bright Yellow</td>
<td style="text-align: left;"><code>93</code></td>
<td style="text-align: left;"><code>103</code></td>
</tr>
<tr class="odd">
<td style="text-align: left;">Bright Blue</td>
<td style="text-align: left;"><code>94</code></td>
<td style="text-align: left;"><code>104</code></td>
</tr>
<tr class="even">
<td style="text-align: left;">Bright Magenta</td>
<td style="text-align: left;"><code>95</code></td>
<td style="text-align: left;"><code>105</code></td>
</tr>
<tr class="odd">
<td style="text-align: left;">Bright Cyan</td>
<td style="text-align: left;"><code>96</code></td>
<td style="text-align: left;"><code>106</code></td>
</tr>
<tr class="even">
<td style="text-align: left;">Bright White</td>
<td style="text-align: left;"><code>97</code></td>
<td style="text-align: left;"><code>107</code></td>
</tr>
</tbody>
</table>
<h4 id="colors-1">256 Colors</h4>
<p>The following escape codes tells the terminal to use the given color ID:</p>
<table>
<thead>
<tr class="header">
<th style="text-align: left;">ESC Code Sequence</th>
<th style="text-align: left;">Description</th>
</tr>
</thead>
<tbody>
<tr class="odd">
<td style="text-align: left;"><code>ESC[38;5;{ID}m</code></td>
<td style="text-align: left;">Set foreground color.</td>
</tr>
<tr class="even">
<td style="text-align: left;"><code>ESC[48;5;{ID}m</code></td>
<td style="text-align: left;">Set background color.</td>
</tr>
</tbody>
</table>
<p>Where <code>{ID}</code> should be replaced with the color index from 0 to 255 of the following color table:</p>
<figure>
<img src="https://user-images.githubusercontent.com/995050/47952855-ecb12480-df75-11e8-89d4-ac26c50e80b9.png" alt="256 Color table" /><figcaption>256 Color table</figcaption>
</figure>
<p>The table starts with the original 16 colors (0-15).</p>
<p>The proceeding 216 colors (16-231) or formed by a 3bpc RGB value offset by 16, packed into a single value.</p>
<p>The final 24 colors (232-255) are grayscale starting from a shade slighly lighter than black, ranging up to shade slightly darker than white.</p>
<p>Some emulators interpret these steps as linear increments (<code>256 / 24</code>) on all three channels, although some emulators may explicitly define these values.</p>
<h4 id="rgb-colors">RGB Colors</h4>
<p>More modern terminals supports <a href="https://en.wikipedia.org/wiki/Color_depth#True_color_.2824-bit.29">Truecolor</a> (24-bit RGB), which allows you to set foreground and background colors using RGB.</p>
<p>These escape sequences are usually not well documented.</p>
<table>
<thead>
<tr class="header">
<th style="text-align: left;">ESC Code Sequence</th>
<th style="text-align: left;">Description</th>
</tr>
</thead>
<tbody>
<tr class="odd">
<td style="text-align: left;"><code>ESC[38;2;{r};{g};{b}m</code></td>
<td style="text-align: left;">Set foreground color as RGB.</td>
</tr>
<tr class="even">
<td style="text-align: left;"><code>ESC[48;2;{r};{g};{b}m</code></td>
<td style="text-align: left;">Set background color as RGB.</td>
</tr>
</tbody>
</table>
<blockquote>
<p>Note that <code>;38</code> and <code>;48</code> corresponds to the 16 color sequence and is interpreted by the terminal to set the foreground and background color respectively. Where as <code>;2</code> and <code>;5</code> sets the color format.</p>
</blockquote>
<h2 id="screen-modes">Screen Modes</h2>
<h3 id="set-mode">Set Mode</h3>
<table>
<colgroup>
<col style="width: 9%" />
<col style="width: 90%" />
</colgroup>
<thead>
<tr class="header">
<th style="text-align: left;">ESC Code Sequence</th>
<th style="text-align: left;">Description</th>
</tr>
</thead>
<tbody>
<tr class="odd">
<td style="text-align: left;"><code>ESC[={value}h</code></td>
<td style="text-align: left;">Changes the screen width or type to the mode specified by value.</td>
</tr>
<tr class="even">
<td style="text-align: left;"><code>ESC[=0h</code></td>
<td style="text-align: left;">40 x 25 monochrome (text)</td>
</tr>
<tr class="odd">
<td style="text-align: left;"><code>ESC[=1h</code></td>
<td style="text-align: left;">40 x 25 color (text)</td>
</tr>
<tr class="even">
<td style="text-align: left;"><code>ESC[=2h</code></td>
<td style="text-align: left;">80 x 25 monochrome (text)</td>
</tr>
<tr class="odd">
<td style="text-align: left;"><code>ESC[=3h</code></td>
<td style="text-align: left;">80 x 25 color (text)</td>
</tr>
<tr class="even">
<td style="text-align: left;"><code>ESC[=4h</code></td>
<td style="text-align: left;">320 x 200 4-color (graphics)</td>
</tr>
<tr class="odd">
<td style="text-align: left;"><code>ESC[=5h</code></td>
<td style="text-align: left;">320 x 200 monochrome (graphics)</td>
</tr>
<tr class="even">
<td style="text-align: left;"><code>ESC[=6h</code></td>
<td style="text-align: left;">640 x 200 monochrome (graphics)</td>
</tr>
<tr class="odd">
<td style="text-align: left;"><code>ESC[=7h</code></td>
<td style="text-align: left;">Enables line wrapping</td>
</tr>
<tr class="even">
<td style="text-align: left;"><code>ESC[=13h</code></td>
<td style="text-align: left;">320 x 200 color (graphics)</td>
</tr>
<tr class="odd">
<td style="text-align: left;"><code>ESC[=14h</code></td>
<td style="text-align: left;">640 x 200 color (16-color graphics)</td>
</tr>
<tr class="even">
<td style="text-align: left;"><code>ESC[=15h</code></td>
<td style="text-align: left;">640 x 350 monochrome (2-color graphics)</td>
</tr>
<tr class="odd">
<td style="text-align: left;"><code>ESC[=16h</code></td>
<td style="text-align: left;">640 x 350 color (16-color graphics)</td>
</tr>
<tr class="even">
<td style="text-align: left;"><code>ESC[=17h</code></td>
<td style="text-align: left;">640 x 480 monochrome (2-color graphics)</td>
</tr>
<tr class="odd">
<td style="text-align: left;"><code>ESC[=18h</code></td>
<td style="text-align: left;">640 x 480 color (16-color graphics)</td>
</tr>
<tr class="even">
<td style="text-align: left;"><code>ESC[=19h</code></td>
<td style="text-align: left;">320 x 200 color (256-color graphics)</td>
</tr>
<tr class="odd">
<td style="text-align: left;"><code>ESC[={value}l</code></td>
<td style="text-align: left;">Resets the mode by using the same values that Set Mode uses, except for 7, which disables line wrapping. The last character in this escape sequence is a lowercase L.</td>
</tr>
</tbody>
</table>
<h3 id="common-private-modes">Common Private Modes</h3>
<p>These are some examples of private modes, which are not defined by the specification, but are implemented in most terminals.</p>
<table>
<thead>
<tr class="header">
<th style="text-align: left;">ESC Code Sequence</th>
<th style="text-align: left;">Description</th>
</tr>
</thead>
<tbody>
<tr class="odd">
<td style="text-align: left;"><code>ESC[?25l</code></td>
<td style="text-align: left;">make cursor invisible</td>
</tr>
<tr class="even">
<td style="text-align: left;"><code>ESC[?25h</code></td>
<td style="text-align: left;">make cursor visible</td>
</tr>
<tr class="odd">
<td style="text-align: left;"><code>ESC[?47l</code></td>
<td style="text-align: left;">restore screen</td>
</tr>
<tr class="even">
<td style="text-align: left;"><code>ESC[?47h</code></td>
<td style="text-align: left;">save screen</td>
</tr>
<tr class="odd">
<td style="text-align: left;"><code>ESC[?1049h</code></td>
<td style="text-align: left;">enables the alternative buffer</td>
</tr>
<tr class="even">
<td style="text-align: left;"><code>ESC[?1049l</code></td>
<td style="text-align: left;">disables the alternative buffer</td>
</tr>
</tbody>
</table>
<p>Refer to the <a href="https://invisible-island.net/xterm/ctlseqs/ctlseqs.html">XTerm Control Sequences</a> for a more in-depth list of private modes defined by XTerm.</p>
<blockquote>
<p>Note: While these modes may be supported by the most terminals, some may not work in multiplexers like tmux.</p>
</blockquote>
<h3 id="keyboard-strings">Keyboard Strings</h3>
<div class="sourceCode" id="cb3"><pre class="sourceCode sh"><code class="sourceCode bash"><a class="sourceLine" id="cb3-1" title="1"><span class="ex">ESC</span>[<span class="dt">{code}</span><span class="kw">;</span><span class="dt">{string}</span>;<span class="dt">{...}</span><span class="ex">p</span></a></code></pre></div>
<p>Redefines a keyboard key to a specified string.</p>
<p>The parameters for this escape sequence are defined as follows:</p>
<ul>
<li><p><code>code</code> is one or more of the values listed in the following table. These values represent keyboard keys and key combinations. When using these values in a command, you must type the semicolons shown in this table in addition to the semicolons required by the escape sequence. The codes in parentheses are not available on some keyboards. <code>ANSI.SYS</code> will not interpret the codes in parentheses for those keyboards unless you specify the <code>/X</code> switch in the <code>DEVICE</code> command for <code>ANSI.SYS</code>.</p></li>
<li><p><code>string</code> is either the ASCII code for a single character or a string contained in quotation marks. For example, both 65 and “A” can be used to represent an uppercase A.</p></li>
</ul>
<blockquote>
<p><strong>IMPORTANT:</strong> Some of the values in the following table are not valid for all computers. Check your computer’s documentation for values that are different.</p>
</blockquote>
<h4 id="list-of-keyboard-strings">List of keyboard strings</h4>
<table>
<thead>
<tr class="header">
<th>Key</th>
<th>Code</th>
<th>SHIFT+code</th>
<th>CTRL+code</th>
<th>ALT+code</th>
</tr>
</thead>
<tbody>
<tr class="odd">
<td>F1</td>
<td>0;59</td>
<td>0;84</td>
<td>0;94</td>
<td>0;104</td>
</tr>
<tr class="even">
<td>F2</td>
<td>0;60</td>
<td>0;85</td>
<td>0;95</td>
<td>0;105</td>
</tr>
<tr class="odd">
<td>F3</td>
<td>0;61</td>
<td>0;86</td>
<td>0;96</td>
<td>0;106</td>
</tr>
<tr class="even">
<td>F4</td>
<td>0;62</td>
<td>0;87</td>
<td>0;97</td>
<td>0;107</td>
</tr>
<tr class="odd">
<td>F5</td>
<td>0;63</td>
<td>0;88</td>
<td>0;98</td>
<td>0;108</td>
</tr>
<tr class="even">
<td>F6</td>
<td>0;64</td>
<td>0;89</td>
<td>0;99</td>
<td>0;109</td>
</tr>
<tr class="odd">
<td>F7</td>
<td>0;65</td>
<td>0;90</td>
<td>0;100</td>
<td>0;110</td>
</tr>
<tr class="even">
<td>F8</td>
<td>0;66</td>
<td>0;91</td>
<td>0;101</td>
<td>0;111</td>
</tr>
<tr class="odd">
<td>F9</td>
<td>0;67</td>
<td>0;92</td>
<td>0;102</td>
<td>0;112</td>
</tr>
<tr class="even">
<td>F10</td>
<td>0;68</td>
<td>0;93</td>
<td>0;103</td>
<td>0;113</td>
</tr>
<tr class="odd">
<td>F11</td>
<td>0;133</td>
<td>0;135</td>
<td>0;137</td>
<td>0;139</td>
</tr>
<tr class="even">
<td>F12</td>
<td>0;134</td>
<td>0;136</td>
<td>0;138</td>
<td>0;140</td>
</tr>
<tr class="odd">
<td>HOME (num keypad)</td>
<td>0;71</td>
<td>55</td>
<td>0;119</td>
<td>--</td>
</tr>
<tr class="even">
<td>UP ARROW (num keypad)</td>
<td>0;72</td>
<td>56</td>
<td>(0;141)</td>
<td>--</td>
</tr>
<tr class="odd">
<td>PAGE UP (num keypad)</td>
<td>0;73</td>
<td>57</td>
<td>0;132</td>
<td>--</td>
</tr>
<tr class="even">
<td>LEFT ARROW (num keypad)</td>
<td>0;75</td>
<td>52</td>
<td>0;115</td>
<td>--</td>
</tr>
<tr class="odd">
<td>RIGHT ARROW (num keypad)</td>
<td>0;77</td>
<td>54</td>
<td>0;116</td>
<td>--</td>
</tr>
<tr class="even">
<td>END (num keypad)</td>
<td>0;79</td>
<td>49</td>
<td>0;117</td>
<td>--</td>
</tr>
<tr class="odd">
<td>DOWN ARROW (num keypad)</td>
<td>0;80</td>
<td>50</td>
<td>(0;145)</td>
<td>--</td>
</tr>
<tr class="even">
<td>PAGE DOWN (num keypad)</td>
<td>0;81</td>
<td>51</td>
<td>0;118</td>
<td>--</td>
</tr>
<tr class="odd">
<td>INSERT (num keypad)</td>
<td>0;82</td>
<td>48</td>
<td>(0;146)</td>
<td>--</td>
</tr>
<tr class="even">
<td>DELETE (num keypad)</td>
<td>0;83</td>
<td>46</td>
<td>(0;147)</td>
<td>--</td>
</tr>
<tr class="odd">
<td>HOME</td>
<td>(224;71)</td>
<td>(224;71)</td>
<td>(224;119)</td>
<td>(224;151)</td>
</tr>
<tr class="even">
<td>UP ARROW</td>
<td>(224;72)</td>
<td>(224;72)</td>
<td>(224;141)</td>
<td>(224;152)</td>
</tr>
<tr class="odd">
<td>PAGE UP</td>
<td>(224;73)</td>
<td>(224;73)</td>
<td>(224;132)</td>
<td>(224;153)</td>
</tr>
<tr class="even">
<td>LEFT ARROW</td>
<td>(224;75)</td>
<td>(224;75)</td>
<td>(224;115)</td>
<td>(224;155)</td>
</tr>
<tr class="odd">
<td>RIGHT ARROW</td>
<td>(224;77)</td>
<td>(224;77)</td>
<td>(224;116)</td>
<td>(224;157)</td>
</tr>
<tr class="even">
<td>END</td>
<td>(224;79)</td>
<td>(224;79)</td>
<td>(224;117)</td>
<td>(224;159)</td>
</tr>
<tr class="odd">
<td>DOWN ARROW</td>
<td>(224;80)</td>
<td>(224;80)</td>
<td>(224;145)</td>
<td>(224;154)</td>
</tr>
<tr class="even">
<td>PAGE DOWN</td>
<td>(224;81)</td>
<td>(224;81)</td>
<td>(224;118)</td>
<td>(224;161)</td>
</tr>
<tr class="odd">
<td>INSERT</td>
<td>(224;82)</td>
<td>(224;82)</td>
<td>(224;146)</td>
<td>(224;162)</td>
</tr>
<tr class="even">
<td>DELETE</td>
<td>(224;83)</td>
<td>(224;83)</td>
<td>(224;147)</td>
<td>(224;163)</td>
</tr>
<tr class="odd">
<td>PRINT SCREEN</td>
<td>--</td>
<td>--</td>
<td>0;114</td>
<td>--</td>
</tr>
<tr class="even">
<td>PAUSE/BREAK</td>
<td>--</td>
<td>--</td>
<td>0;0</td>
<td>--</td>
</tr>
<tr class="odd">
<td>BACKSPACE</td>
<td>8</td>
<td>8</td>
<td>127</td>
<td>(0)</td>
</tr>
<tr class="even">
<td>ENTER</td>
<td>13</td>
<td>--</td>
<td>10</td>
<td>(0</td>
</tr>
<tr class="odd">
<td>TAB</td>
<td>9</td>
<td>0;15</td>
<td>(0;148)</td>
<td>(0;165)</td>
</tr>
<tr class="even">
<td>NULL</td>
<td>0;3</td>
<td>--</td>
<td>--</td>
<td>--</td>
</tr>
<tr class="odd">
<td>A</td>
<td>97</td>
<td>65</td>
<td>1</td>
<td>0;30</td>
</tr>
<tr class="even">
<td>B</td>
<td>98</td>
<td>66</td>
<td>2</td>
<td>0;48</td>
</tr>
<tr class="odd">
<td>C</td>
<td>99</td>
<td>66</td>
<td>3</td>
<td>0;46</td>
</tr>
<tr class="even">
<td>D</td>
<td>100</td>
<td>68</td>
<td>4</td>
<td>0;32</td>
</tr>
<tr class="odd">
<td>E</td>
<td>101</td>
<td>69</td>
<td>5</td>
<td>0;18</td>
</tr>
<tr class="even">
<td>F</td>
<td>102</td>
<td>70</td>
<td>6</td>
<td>0;33</td>
</tr>
<tr class="odd">
<td>G</td>
<td>103</td>
<td>71</td>
<td>7</td>
<td>0;34</td>
</tr>
<tr class="even">
<td>H</td>
<td>104</td>
<td>72</td>
<td>8</td>
<td>0;35</td>
</tr>
<tr class="odd">
<td>I</td>
<td>105</td>
<td>73</td>
<td>9</td>
<td>0;23</td>
</tr>
<tr class="even">
<td>J</td>
<td>106</td>
<td>74</td>
<td>10</td>
<td>0;36</td>
</tr>
<tr class="odd">
<td>K</td>
<td>107</td>
<td>75</td>
<td>11</td>
<td>0;37</td>
</tr>
<tr class="even">
<td>L</td>
<td>108</td>
<td>76</td>
<td>12</td>
<td>0;38</td>
</tr>
<tr class="odd">
<td>M</td>
<td>109</td>
<td>77</td>
<td>13</td>
<td>0;50</td>
</tr>
<tr class="even">
<td>N</td>
<td>110</td>
<td>78</td>
<td>14</td>
<td>0;49</td>
</tr>
<tr class="odd">
<td>O</td>
<td>111</td>
<td>79</td>
<td>15</td>
<td>0;24</td>
</tr>
<tr class="even">
<td>P</td>
<td>112</td>
<td>80</td>
<td>16</td>
<td>0;25</td>
</tr>
<tr class="odd">
<td>Q</td>
<td>113</td>
<td>81</td>
<td>17</td>
<td>0;16</td>
</tr>
<tr class="even">
<td>R</td>
<td>114</td>
<td>82</td>
<td>18</td>
<td>0;19</td>
</tr>
<tr class="odd">
<td>S</td>
<td>115</td>
<td>83</td>
<td>19</td>
<td>0;31</td>
</tr>
<tr class="even">
<td>T</td>
<td>116</td>
<td>84</td>
<td>20</td>
<td>0;20</td>
</tr>
<tr class="odd">
<td>U</td>
<td>117</td>
<td>85</td>
<td>21</td>
<td>0;22</td>
</tr>
<tr class="even">
<td>V</td>
<td>118</td>
<td>86</td>
<td>22</td>
<td>0;47</td>
</tr>
<tr class="odd">
<td>W</td>
<td>119</td>
<td>87</td>
<td>23</td>
<td>0;17</td>
</tr>
<tr class="even">
<td>X</td>
<td>120</td>
<td>88</td>
<td>24</td>
<td>0;45</td>
</tr>
<tr class="odd">
<td>Y</td>
<td>121</td>
<td>89</td>
<td>25</td>
<td>0;21</td>
</tr>
<tr class="even">
<td>Z</td>
<td>122</td>
<td>90</td>
<td>26</td>
<td>0;44</td>
</tr>
<tr class="odd">
<td>1</td>
<td>49</td>
<td>33</td>
<td>--</td>
<td>0;120</td>
</tr>
<tr class="even">
<td>2</td>
<td>50</td>
<td>64</td>
<td>0</td>
<td>0;121</td>
</tr>
<tr class="odd">
<td>3</td>
<td>51</td>
<td>35</td>
<td>--</td>
<td>0;122</td>
</tr>
<tr class="even">
<td>4</td>
<td>52</td>
<td>36</td>
<td>--</td>
<td>0;123</td>
</tr>
<tr class="odd">
<td>5</td>
<td>53</td>
<td>37</td>
<td>--</td>
<td>0;124</td>
</tr>
<tr class="even">
<td>6</td>
<td>54</td>
<td>94</td>
<td>30</td>
<td>0;125</td>
</tr>
<tr class="odd">
<td>7</td>
<td>55</td>
<td>38</td>
<td>--</td>
<td>0;126</td>
</tr>
<tr class="even">
<td>8</td>
<td>56</td>
<td>42</td>
<td>--</td>
<td>0;126</td>
</tr>
<tr class="odd">
<td>9</td>
<td>57</td>
<td>40</td>
<td>--</td>
<td>0;127</td>
</tr>
<tr class="even">
<td>0</td>
<td>48</td>
<td>41</td>
<td>--</td>
<td>0;129</td>
</tr>
<tr class="odd">
<td>-</td>
<td>45</td>
<td>95</td>
<td>31</td>
<td>0;130</td>
</tr>
<tr class="even">
<td>=</td>
<td>61</td>
<td>43</td>
<td>-–</td>
<td>0;131</td>
</tr>
<tr class="odd">
<td>[</td>
<td>91</td>
<td>123</td>
<td>27</td>
<td>0;26</td>
</tr>
<tr class="even">
<td>]</td>
<td>93</td>
<td>125</td>
<td>29</td>
<td>0;27</td>
</tr>
<tr class="odd">
<td></td>
<td>92</td>
<td>124</td>
<td>28</td>
<td>0;43</td>
</tr>
<tr class="even">
<td>;</td>
<td>59</td>
<td>58</td>
<td>--</td>
<td>0;39</td>
</tr>
<tr class="odd">
<td>’</td>
<td>39</td>
<td>34</td>
<td>--</td>
<td>0;40</td>
</tr>
<tr class="even">
<td>,</td>
<td>44</td>
<td>60</td>
<td>--</td>
<td>0;51</td>
</tr>
<tr class="odd">
<td>.</td>
<td>46</td>
<td>62</td>
<td>--</td>
<td>0;52</td>
</tr>
<tr class="even">
<td>/</td>
<td>47</td>
<td>63</td>
<td>--</td>
<td>0;53</td>
</tr>
<tr class="odd">
<td>`</td>
<td>96</td>
<td>126</td>
<td>--</td>
<td>(0;41)</td>
</tr>
<tr class="even">
<td>ENTER (keypad)</td>
<td>13</td>
<td>--</td>
<td>10</td>
<td>(0;166)</td>
</tr>
<tr class="odd">
<td>/ (keypad)</td>
<td>47</td>
<td>47</td>
<td>(0;142)</td>
<td>(0;74)</td>
</tr>
<tr class="even">
<td>* (keypad)</td>
<td>42</td>
<td>(0;144)</td>
<td>(0;78)</td>
<td>--</td>
</tr>
<tr class="odd">
<td>- (keypad)</td>
<td>45</td>
<td>45</td>
<td>(0;149)</td>
<td>(0;164)</td>
</tr>
<tr class="even">
<td>+ (keypad)</td>
<td>43</td>
<td>43</td>
<td>(0;150)</td>
<td>(0;55)</td>
</tr>
<tr class="odd">
<td>5 (keypad)</td>
<td>(0;76)</td>
<td>53</td>
<td>(0;143)</td>
<td>--</td>
</tr>
</tbody>
</table>
<h2 id="resources">Resources</h2>
<ul>
<li><a href="https://en.wikipedia.org/wiki/ANSI_escape_code">Wikipedia: ANSI escape code</a></li>
<li><a href="http://www.lihaoyi.com/post/BuildyourownCommandLinewithANSIescapecodes.html">Build your own Command Line with ANSI escape codes</a></li>
<li><a href="http://ascii-table.com/ansi-escape-sequences.php">ascii-table: ANSI Escape sequences</a></li>
<li><a href="https://bluesock.org/~willkg/dev/ansi.html">bluesock: ansi codes</a></li>
<li><a href="http://wiki.bash-hackers.org/scripting/terminalcodes">bash-hackers: Terminal Codes (ANSI/VT100) introduction</a></li>
<li><a href="https://invisible-island.net/xterm/ctlseqs/ctlseqs.html">XTerm Control Sequences</a></li>
<li><a href="https://vt100.net/">VT100 – Various terminal manuals</a></li>
</ul>
</body>
</html>
